# Enum Class Connector

java.lang.Object
java.lang.Enum<Connector>
it.polimi.ingsw.is25am31.model.components.Connector

All Implemented Interfaces:
  `Serializable`, `Comparable<Connector>`, `Constable`

public enum Connector extends Enum<Connector> implements Serializable
Enumeration representing the different types of connectors available in the game. This enum defines the various connector types that can be used to link, attach, or interface different game components. Connectors determine how game elements can be combined, connected, or interact with each other within the game system. This enum implements `Serializable` to support serialization of connector data for game state persistence, network communication, or other data storage requirements. The available connector types are: `SINGLE` - Single connection point, `DOUBLE` - Double connection point, `UNIVERSAL` - Universal connector (compatible with all types), `NONE` - No connector present, `ENGINE` - Engine-specific connector, `CANNON` - Cannon-specific connector.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `CANNON`
  `DOUBLE`
  `ENGINE`
  `NONE`
  `SINGLE`
  `UNIVERSAL`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Connector`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static Connector[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### SINGLE

    public static final Connector SINGLE

  - ### DOUBLE

    public static final Connector DOUBLE

  - ### UNIVERSAL

    public static final Connector UNIVERSAL

  - ### NONE

    public static final Connector NONE

  - ### ENGINE

    public static final Connector ENGINE

  - ### CANNON

    public static final Connector CANNON

- ## Method Details

  - ### values

    public static Connector[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static Connector valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null